using System;
using System.Text;
using System.Text.RegularExpressions;
using Microsoft.AnalysisServices.AdomdServer;

namespace StoredProcedureOM
{
    public class SetOperations
    {
        public Set FilterEvenMembers(Set inputSet)
        {
            SetBuilder setBuilder = new SetBuilder();
            int rank = 0;
            foreach (Tuple tuple in inputSet.Tuples)
            {
                if ((rank/2)*2 == rank)
                    setBuilder.Add(tuple);
                rank++;
            }
            return setBuilder.ToSet();
        }

        // Fiter the set by the regular expression passed to the function
        public Set FilterByRegEx(Set inputSet, string stringRegEx)
        {
            Regex rx = new Regex(stringRegEx);
            SetBuilder setBuilder = new SetBuilder();
            foreach (Tuple tuple in inputSet.Tuples)
            {
               if (rx.IsMatch(tuple.Members[0].Caption))
                   setBuilder.Add(tuple);
            }
            return setBuilder.ToSet();
        }
    }
}
